// TestPreviewView.cpp : implementation of the CTestPreviewView class
//

#include "stdafx.h"
#include "TestPreview.h"

#include "TestPreviewDoc.h"
#include "TestPreviewView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// For view online profile, report bugs, and download other tons of C++ MFC Sample source codes
// please visit: http://www.ucancode.net

/////////////////////////////////////////////////////////////////////////////
// CTestPreviewView

IMPLEMENT_DYNCREATE(CTestPreviewView, CScrollView)

BEGIN_MESSAGE_MAP(CTestPreviewView, CScrollView)
	//{{AFX_MSG_MAP(CTestPreviewView)
	ON_WM_SIZE()
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, OnFilePrintPreview)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestPreviewView construction/destruction

CTestPreviewView::CTestPreviewView()
{
	// TODO: add construction code here
	SetScrollSizes(MM_TEXT, CSize(0, 0));
	m_bPrint = FALSE;
	CWindowDC dc (NULL);
	m_nLogPixelsY		= dc.GetDeviceCaps (LOGPIXELSY);
	m_nLogPixelsX		= dc.GetDeviceCaps (LOGPIXELSX);

}

CTestPreviewView::~CTestPreviewView()
{
}

BOOL CTestPreviewView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CTestPreviewView drawing

void CTestPreviewView::OnDraw(CDC* pDC)
{
	CTestPreviewDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here

	CRect rcPos = CRect(80,80,200,200);
	pDC->Rectangle(&rcPos);

	rcPos.OffsetRect(CPoint(100,100));

	pDC->Ellipse(&rcPos);

	rcPos.OffsetRect(CPoint(60,100));

	rcPos.right = rcPos.left + 300;

	pDC->DrawText(_T("Just testing print preview only!"), &rcPos, DT_LEFT|DT_VCENTER|DT_SINGLELINE);
}

void CTestPreviewView::OnInitialUpdate()
{
	ResyncScrollSizes();
	CScrollView::OnInitialUpdate();
}

/////////////////////////////////////////////////////////////////////////////
// CTestPreviewView printing

BOOL CTestPreviewView::OnPreparePrinting(CPrintInfo* pInfo)
{
	pInfo->SetMaxPage(1);   // the document is two pages long:
							// the first page is the title page
							// the second is the drawing
	BOOL bRet = DoPreparePrinting(pInfo);	// default preparation
	pInfo->m_nNumPreviewPages = 1;  // Preview 2 pages at a time
	// Set this value after calling DoPreparePrinting to override
	// value read from .INI file
	return bRet;
}

void CTestPreviewView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
	m_bPrint = TRUE;
}

void CTestPreviewView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
	m_bPrint = FALSE;
}

void CTestPreviewView::ResyncScrollSizes()
{
	CClientDC dc(NULL);
	OnPrepareDC(&dc);
	CSize sizeDoc = CSize(1000,1000);
	dc.LPtoDP(&sizeDoc);
	SetScrollSizes(MM_TEXT, sizeDoc);
}

/////////////////////////////////////////////////////////////////////////////
// CTestPreviewView diagnostics

#ifdef _DEBUG
void CTestPreviewView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CTestPreviewView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CTestPreviewDoc* CTestPreviewView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTestPreviewDoc)));
	return (CTestPreviewDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTestPreviewView message handlers

void CTestPreviewView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	// TODO: Add your specialized code here and/or call the base class
	rcPrint = pInfo->m_rectDraw;
	// Now print the rest of the page
	CBrush br(RGB(255,255,255));
	pDC->FillRect(&rcPrint, &br);
	br.DeleteObject();

	OnDraw(pDC);
}

BOOL CTestPreviewView::ScaleToDeviceRes(CDC* pDC, CSize& szNew)
{
	BOOL bReturn = FALSE;
	
	CDC dcScreen;
	dcScreen.CreateCompatibleDC(0);
	
	int nLogPixelX = dcScreen.GetDeviceCaps(LOGPIXELSX);
	int nLogPixelY = dcScreen.GetDeviceCaps(LOGPIXELSY);
	int nDevPixelX = pDC->GetDeviceCaps(LOGPIXELSX);
	int nDevPixelY = pDC->GetDeviceCaps(LOGPIXELSY);
	
	if (nLogPixelX != nDevPixelX || nLogPixelY != nDevPixelY)
	{
		szNew.cx = (szNew.cx * nDevPixelX) / nLogPixelX;
		szNew.cy = (szNew.cy * nDevPixelY) / nLogPixelY;
		bReturn = TRUE;
	}

	return bReturn;
}

void CTestPreviewView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo) 
{
	CScrollView::OnPrepareDC(pDC, pInfo);

	pDC->SetMapMode(MM_ANISOTROPIC);
	CSize sizeDoc = CSize(1000,1000);

	pDC->SetWindowExt(sizeDoc);
	ScaleToDeviceRes(pDC,sizeDoc);

	pDC->SetViewportExt(sizeDoc);
}

void CTestPreviewView::OnSize(UINT nType, int cx, int cy) 
{
	ResyncScrollSizes();        // ensure that scroll info is up-to-date
	CScrollView::OnSize(nType, cx, cy);
}

void CTestPreviewView::OnFilePrintPreview() 
{
	// TODO: Add your command handler code here
	FOPrintPreview(this);
}
